#
# Conditional build:
%bcond_without	gnutls		# TLS transport (GnuTLS based)
%bcond_with	kerberos5	# GSSAPI client support [expects MIT Kerberos]
%bcond_with	norm		# NORM extension
%bcond_without	pgm		# PGM extension (using OpenPGM library)
%bcond_without	tests		# build without tests

Summary:	0MQ - Zero Message Queue
Summary(en.UTF-8):	ØMQ - Zero Message Queue
Summary(pl.UTF-8):	ØMQ (Zero Message Queue) - kolejka komunikatów
Name:		zeromq
Version:	4.3.5
Release:	1
License:	MPL v2.0
Group:		Libraries
#Source0Download: https://github.com/zeromq/libzmq/releases/
Source0:	https://github.com/zeromq/libzmq/releases/download/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	ae933b1e98411fd7cb8309f9502d2737
URL:		http://www.zeromq.org/
BuildRequires:	asciidoc
BuildRequires:	autoconf >= 2.61
BuildRequires:	automake
%{?with_gnutls:BuildRequires:	gnutls-devel >= 3.1.4}
%{?with_krb5:BuildRequires:	krb5-devel}
BuildRequires:	libbsd-devel
# 5.1, 5.2, 5.3 are supported
%{?with_pgm:BuildRequires:	libpgm-devel >= 5.1}
%{?with_pgm:BuildRequires:	libpgm-devel < 5.4}
BuildRequires:	libsodium-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtool
BuildRequires:	libunwind-devel
BuildRequires:	libuuid-devel
%{?with_norm:BuildRequires:	norm-devel}
BuildRequires:	pkgconfig
BuildRequires:	sed >= 4.0
BuildRequires:	xmlto
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The 0MQ lightweight messaging kernel is a library which extends the
standard socket interfaces with features traditionally provided by
specialised messaging middleware products. 0MQ sockets provide an
abstraction of asynchronous message queues, multiple messaging
patterns, message filtering (subscriptions), seamless access to
multiple transport protocols and more.

%description -l en.UTF-8
The ØMQ lightweight messaging kernel is a library which extends the
standard socket interfaces with features traditionally provided by
specialised messaging middleware products. ØMQ sockets provide an
abstraction of asynchronous message queues, multiple messaging
patterns, message filtering (subscriptions), seamless access to
multiple transport protocols and more.

%description -l pl.UTF-8
Lekkie jądro przekazywania komunikatów ØMQ to biblioteka rozszerzająca
standardowe interfejsy gniazd o możliwości zwykle udostępniane przez
specjalizowane produkty warstwy pośredniej do przekazywania
komunikatów. Gniazda ØMQ udostępniają abstrakcję asynchronicznych
kolejek komunikatów, wiele wzorców przekazywania komunikatów,
filtrowanie komunikatów (subskrypce), przezroczysty dostęp do wielu
protokołów transportowych i wiele innych możliwości.

%package devel
Summary:	0MQ library header files for development
Summary(en.UTF-8):	ØMQ library header files for development
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki ØMQ
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%{?with_gnutls:Requires:	gnutls >= 3.1.4}
Requires:	libbsd-devel
%{?with_pgm:Requires:	libpgm-devel >= 5.1}
Requires:	libsodium-devel
Requires:	libstdc++-devel
Requires:	libunwind-devel
Obsoletes:	zeromq-pthreads-devel < 2

%description devel
0MQ library header files for development.

%description devel -l en.UTF-8
ØMQ library header files for development.

%description devel -l pl.UTF-8
Pliki nagłówkowe biblioteki ØMQ.

%package static
Summary:	Static 0MQ library
Summary(en.UTF-8):	Static ØMQ library
Summary(pl.UTF-8):	Statyczna biblioteka ØMQ
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Obsoletes:	zeromq-pthreads-static < 2

%description static
Static 0MQ library.

%description static -l en.UTF-8
Static ØMQ library.

%description static -l pl.UTF-8
Statyczna biblioteka ØMQ.

%package -n cppzmq-devel
Summary:	Development files for cppzmq
Summary(pl.UTF-8):	Pliki programistyczne cppzmq
Group:		Development/Libraries
License:	MIT
Requires:	%{name}-devel = %{version}-%{release}

%description -n cppzmq-devel
The cppzmq-devel package contains the header file for developing
applications that use the C++ interface for 0MQ.

%description -n cppzmq-devel -l pl.UTF-8
Ten pakiet zawiera plik nagłówkowy do tworzenia aplikacji
wykorzystujących interfejs C++ do ØMQ.

%prep
%setup -q

# uses some multicast networking, timeouts on some hosts
%{__sed} -i -e '/^\s*tests\/test_radio_dish /d' Makefile.am

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__automake}
%{__autoheader}
%configure \
	--enable-drafts \
	--disable-silent-rules \
	%{?with_kerberos5:--with-libgssapi_krb5} \
	--with-libsodium \
	%{?with_norm:--with-norm} \
	%{?with_pgm:--with-pgm} \
	%{?with_gnutls:--with-tls} \
	--disable-Werror
%{__make}

%if %{with tests}
%{__make} check -j1
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/*.la

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog NEWS
%attr(755,root,root) %{_bindir}/curve_keygen
%attr(755,root,root) %{_libdir}/libzmq.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libzmq.so.5

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libzmq.so
%{_includedir}/zmq.h
%{_includedir}/zmq_utils.h
%{_pkgconfigdir}/libzmq.pc
%{_mandir}/man3/zmq*.3*
%{_mandir}/man7/zmq*.7*

%files static
%defattr(644,root,root,755)
%{_libdir}/libzmq.a
%changelog
* Tue Nov 28 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/zeromq.git;a=log;h=master

* Tue Nov 28 2023 Jakub Bogusz <qboosh@pld-linux.org> 489700c
- updated to 4.3.5 (relicensed to MPL v2.0 now)

* Sun Nov 26 2023 Jan Rękorajski <baggins@pld-linux.org> 6b73ac1
- Release 2 (by relup.sh)

* Sat May 21 2022 Jan Palus <atler@pld-linux.org> 10cdc5f
- disable -Werror to fix build with gcc >= 11

* Tue Apr 27 2021 Jakub Bogusz <qboosh@pld-linux.org> ea4cb5c
- updated to 4.3.4

* Mon Sep 21 2020 Jakub Bogusz <qboosh@pld-linux.org> b14946a
- disable test_radio_dish test; release 2

* Sun Sep 20 2020 Jakub Bogusz <qboosh@pld-linux.org> 4e73b43
- updated to 4.3.3, fixes:
  CVE-2020-15166/GHSA-25wp-cf8g-938m GHSA-qq65-x72m-9wr8 GHSA-4p5v-h92w-6wxw GHSA-wfr2-29gj-5w87 GHSA-fc3w-qxf5-7hp6
- enabled TLS support by default (+bcond to disable)

* Sun Jul 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 28049e5
- updated to 4.3.2 (fixes CVE-2019-13132)

* Fri Apr 12 2019 Jakub Bogusz <qboosh@pld-linux.org> aec25d5
- updated to 4.3.1

* Thu Jun 21 2018 Jakub Bogusz <qboosh@pld-linux.org> 9aea439
- updated to 4.2.5

* Mon Dec 25 2017 Jakub Bogusz <qboosh@pld-linux.org> 1c59b9b
- updated to 4.2.3
- cppzmq moved to cppzmq.spec

* Fri Jul 21 2017 Jakub Bogusz <qboosh@pld-linux.org> 1310e01
- updated to 4.2.2
- removed obsolete dl-backport patch

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 2606903
- patch

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 69247a7
- up to 4.2.0

* Sat Dec 03 2016 Jakub Bogusz <qboosh@pld-linux.org> c2b00f6
- pl for cppzmq-devel

* Wed Nov 30 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 9b67e65
- up to 4.1.6; add c++ bindings

* Wed Aug 03 2016 Mariusz Mazur <mmazur@axeos.com> 0ed0f96
- Up to 4.1.5

* Fri Dec 25 2015 Jan Rękorajski <baggins@pld-linux.org> 56fc2e1
- up to 4.1.4, no more warnings

* Fri Dec 25 2015 Jan Rękorajski <baggins@pld-linux.org> 9a04ea0
- disable -Werror (build fails due to harmless warnings)
- rel 3

* Fri Dec 25 2015 Jan Rękorajski <baggins@pld-linux.org> 3455314
- release 2 (by relup.sh)

* Sat Aug 01 2015 Jakub Bogusz <qboosh@pld-linux.org> de74f45
- updated to 4.1.2 (note: new soname)
- added NORM support (on bcond)
- added bcond for GSSAPI (untested, doesn't build with heimdal)

